#if !defined(AFX_OPTIONSDLG_H__613C27C8_0D8E_4A01_BC6A_FE3C0EC6486D__INCLUDED_)
#define AFX_OPTIONSDLG_H__613C27C8_0D8E_4A01_BC6A_FE3C0EC6486D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "BrowseCtrl.h"
// OptionsDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// COptionsDlg dialog

class COptionsDlg : public CDialog
{
// Construction
public:
  CString GetDirectory() const;
  CString GetFileFormat() const;
  CString GetRootflyFileName() const;
	COptionsDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(COptionsDlg)
	enum { IDD = IDD_OPTIONS_DIALOG };
	CSpinButtonCtrl	m_spin_window_order;
	CSpinButtonCtrl	m_spin_tube_order;
	CSpinButtonCtrl	m_spin_session_order;
	CSpinButtonCtrl	m_spin_name_order;
	CEdit	m_edit_window_order;
	CEdit	m_edit_tube_order;
	CEdit	m_edit_session_order;
	CEdit	m_rootfly_name;
	CEdit	m_edit_name_order;
	CEdit	m_edit_name;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COptionsDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(COptionsDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnChangeEditNameOrder();
	afx_msg void OnChangeEditSessionOrder();
	afx_msg void OnChangeEditTubeOrder();
	afx_msg void OnChangeEditWindowOrder();
  afx_msg BOOL CheckOrder();
  afx_msg void SetOrder();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
  CString m_order[4], m_output_dir, m_output_order, m_rootfly_file_name;
  CBrowseCtrl m_dir_browse;
  bool m_bname_changed, m_btube_changed, m_bsession_changed, m_bwindow_changed;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OPTIONSDLG_H__613C27C8_0D8E_4A01_BC6A_FE3C0EC6486D__INCLUDED_)
