#include "Session_Array.h"

#define TABLE_SIZE 10

#include <iostream>
#include <vector>
#include <algorithm>

using std::cout;

Session_Array::Session_Array(){ 

//	sessions = new string[TABLE_SIZE];
//	flags    = new int[TABLE_SIZE];
//  pointer  = 0;
//	maxTableSize = TABLE_SIZE;
//	add_session("0000.00.00");

} // constructor



//int Session_Array::add_session(string inSession){
//
//	int findResult;
//	int returnResult;
//	string *newTable;
//
//	findResult = find_session(inSession);
//
//	if(findResult != -1)
//       return findResult;
//
//	sessions[pointer] = inSession;
//	flags[pointer] = 1;
//	returnResult = pointer;
//	pointer++;
//
//	if(pointer >= maxTableSize){
//		maxTableSize = maxTableSize * 2;
//       newTable = new string[maxTableSize];
//
//	   for(int x = 0; x < pointer; x++)
//		   newTable[x] = sessions[x];
//
//	   sessions = newTable;
//
//	}
//
//	return returnResult;
//
//} // add_session

///* find_session
// * @param: inSession - the date we're looking for
// * @return: int >= 0 if found
//            int = -1 if not found
// */
//
//int Session_Array::find_session(string inSession){
//
//	for(int x=0; x < pointer; x++){
//		if(inSession == sessions[x])
//		   return x;
//    }
//
//	return -1;
//
//} // find_session
//
//
//
//string Session_Array::get_session(int index){
//	return sessions[index];
//} // get_session
//
//int Session_Array::get_year(int index){
//
//	int k = 0;
//    string temp;
//
//	if(index >= pointer || index < 0)
//		return 0000;
//
//	temp = sessions[index];
//
//	return atoi(temp.c_str());
//
//}
//
//int Session_Array::get_month(int index){
//
//	int k = 5;
//    string temp;
//
//		if(index >= pointer || index < 0)
//		return 0000;
//
//	temp = sessions[index];
//
//	return atoi(temp.c_str());
//}
//
//int Session_Array::get_day(int index){
//
//	int k = 8;
//    string temp;
//
//		if(index >= pointer || index < 0)
//		return 0000;
//
//	temp = sessions[index];
//
//	return atoi(temp.c_str());
//}


// Inputs an int date.  If the date is in the vector, return where, else
//    insert the date, resort the vector, return where date is.
int Session_Array::add_date(const Date& date){

   int result;
   //int input_day_of_year;

   result = CheckForDate(date);

   if(result != -1)
	   return result;

//   dates.insert(0,date);
   dates.push_back(date);

   SortArray();

   result = CheckForDate(date);

   return result;

} // add_date()

// ----------------------------------------------------------------------------------------------------------

// Returns the date in the vector at the position specified
// Returns default date (year = month = day = -1) if date not found
Date Session_Array::GetDate(int sessionNumber)
{
  if (sessionNumber <= 0 || sessionNumber > dates.size())  return Date();
  else return dates.at(sessionNumber-1);

} // GetDate()

// ----------------------------------------------------------------------------------------------------------

// Checks vector for date. Returns -1 if date is not found, otherwise, returns
//    current location of date in vector.
int Session_Array::CheckForDate(const Date& date){

/* 05/30/06 - JLF; Updates this to account for a 2 day buffer period,
 * which defines a session. Future updates will allow users to change this
 * buffer period.
 */
  int input_dayOfYear = GetDayOfYear(date.month, date.day, date.year);
  int curr_dayOfYear;

	for(int x=0; x < dates.size(); x++){

    curr_dayOfYear = GetDayOfYear(dates.at(x).month, dates.at(x).day, dates.at(x).year);

    if(input_dayOfYear >= curr_dayOfYear && input_dayOfYear <= curr_dayOfYear + 2)
//    if(date == dates.at(x))
      return x;

  }

	return -1;

} // CheckForDate()

// ----------------------------------------------------------------------------------------------------------

void Session_Array::SortArray(){

  std::sort(dates.begin(), dates.end());
//	int temp;
//	int sort = 0;
//
//	while(sort == 0){
//		sort = 1;
//		for(int x=0; x < dates.size()-1; x++){
//			if(dates[x] > dates[x+1]){
//				temp = dates[x];
//				dates[x] = dates[x+1];
//				dates[x+1] = temp;
//				sort = 0;
//			}
//		}
//	}
} // SortArray()

int Session_Array::GetDayOfYear(int month, int day, int year)
{

  int month_length[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 30, 31, 31};

  if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0)))  
  { month_length[1]++;  /* leap year */ }

  for (int i = 0 ; i < month ; i++)  day += month_length[i];

  return day;

}

//int Session_Array::GetDayOfYear(int month, int day, int year)
//{
//
//  int month_length[12] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 30, 31, 31};
//
//  if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0)))  
//  { month_length[1]++;  /* leap year */ }
//
//  for (int i = 0 ; i < month ; i++)  day += month_length[i];
//
//  return day;
//
//}